(function() {

// constructor
function Button(image) {
    this.Container_constructor();
    
    //add childs
    this._bitmap = new createjs.Bitmap(image);
    this._bitmap.cache(0, 0, image.width, image.height);
    this.addChild(this._bitmap);
    
    this.on("mouseover", this.mouseOverListener, this);
    this.on("mouseout", this.mouseOutListener, this);
};
var p = createjs.extend(Button, createjs.Container);

// public methods:	
p.mouseOverListener = function(e){
    cm = new createjs.ColorMatrix();
    cm.adjustColor(50, 0, 0, 0); //brightness, contrast, saturation, hue
    colorFilter = new createjs.ColorMatrixFilter(cm);
    this._bitmap.filters = [colorFilter];
    this._bitmap.updateCache();
};

p.mouseOutListener = function(e){
    cm = new createjs.ColorMatrix();
    cm.adjustColor(0, 0, 0, 0); //brightness, contrast, saturation, hue
    colorFilter = new createjs.ColorMatrixFilter(cm);
    this._bitmap.filters = [colorFilter];
    this._bitmap.updateCache();
};

window.Button = createjs.promote(Button, "Container");
}());