(function(window) {

//declare class
function Game() {
  this.initialize();
}
var p = Game.prototype;

// static properties:
    Game.STATIC_PROP = 42;
    Game.traits = new Array();
    Game.titles = new Array();
    Game.victimNames = new Array();
    Game.crimes = new Array();
    Game.locations = new Array();

// public properties:
    p.levels = new Array();
   
    
// constructor:
    p.initialize = function() {
        this.createStaticData();
        
        //var level = new Level();
        /*
        level.victimName = 0;
        level.crime = 0;
        level.location = 0;level.suspects.push( {title:0, traits:[0, 2, 3]} );
        level.suspects.push( {title:1, traits:[1, 4, 5]} );
        level.suspects.push( {title:2, traits:[1, 3, 6]} );
        level.murderer = 1;
        */
        /*level.commitCrime();
        level.defineSuspects(3, 2); //suspectCount, traitsPerSuspect
        level.placeClues();
        this.levels.push(level);*/
    };
    
    p.createStaticData = function() {
        //Traits are pre-fixed by 'title' 'is' or 'is NOT' - I.e. The ACTOR is scared of heights
        Game.traits.push( 'left handed' );
        Game.traits.push( 'right handed' );
        Game.traits.push( 'wearing purple underwear' );
        Game.traits.push( 'wearing a pharaoh costume' );
        Game.traits.push( 'a fan of pumpkins' );
        Game.traits.push( 'receiving mental treatment' );
        Game.traits.push( 'receiving medical treatment' );
        Game.traits.push( 'scared of heights' );
        Game.traits.push( 'scared of spiders' );
        Game.traits.push( 'scared of open spaces' );
        Game.traits.push( 'scared of the dark' );
        Game.traits.push( 'scared of the victim' );
        Game.traits.push( 'angry at the victim' );
        Game.traits.push( 'suffering from low self-esteem' );
        Game.traits.push( 'suffering from amnesia' );
        Game.traits.push( 'suffering from a rare illness' );
        Game.traits.push( 'very old' );
        Game.traits.push( 'very small' );
        Game.traits.push( 'a con artist' );
        Game.traits.push( 'a fan of Harry Potter' );
        Game.traits.push( 'a fan of Star Wars' );
        Game.traits.push( 'a fan of Pokemon' );
        Game.traits.push( 'an avid gamer' );
        Game.traits.push( 'an assassin' );
        Game.traits.push( 'an imbecile' );
        Game.traits.push( 'a gambler' );
        Game.traits.push( 'a cyclist' );
        Game.traits.push( 'a hypochondriac' );
        Game.traits.push( 'a gentle person' );
        Game.traits.push( 'in a good mood' );
        Game.traits.push( 'in love with the victim' );
        Game.traits.push( 'an angry person' );
        Game.traits.push( 'in love' );
        Game.traits.push( 'playing World of Warcraft' );
        Game.traits.push( 'playing Grand Theft Auto' );
        Game.traits.push( 'playing Call of Duty' );
        Game.traits.push( 'from another town' );
        Game.traits.push( 'from another country' );
        
        //Titles
        Game.titles.push( 'The BUTLER' );
        Game.titles.push( 'The DESIGNER' );
        Game.titles.push( 'The BOSS' );
        Game.titles.push( 'The DRIVER' );
        Game.titles.push( 'The STUDENT' );
        Game.titles.push( 'The ACTOR' );
        Game.titles.push( 'The LAWYER' );
        Game.titles.push( 'The DRUNK' );
        Game.titles.push( 'The RETARD' );
        Game.titles.push( 'The DOCTOR' );
        Game.titles.push( 'The NEIGHBOR' );
        Game.titles.push( 'The CLEANER' );
        Game.titles.push( 'The BANKER' );
        Game.titles.push( 'The ANALYST' );
        Game.titles.push( 'The MANAGER' );
        Game.titles.push( 'The OFFICER' );
        Game.titles.push( 'The CHEF' );
        Game.titles.push( 'The COOK' );
        Game.titles.push( 'The ENGINEER' );
        Game.titles.push( 'The OPERATOR' );
        Game.titles.push( 'The PLUMBER' );
        Game.titles.push( 'The PAINTER' );
        Game.titles.push( 'The FOREMAN' );
        Game.titles.push( 'The THERAPIST' );
        Game.titles.push( 'The DEALER' );
        Game.titles.push( 'The ANIMATOR' );
        Game.titles.push( 'The STYLIST' );
        Game.titles.push( 'The WAITER' );
        Game.titles.push( 'The ADVISOR' );
        Game.titles.push( 'The SCIENTIST' );
        Game.titles.push( 'The CHEMIST' );
        Game.titles.push( 'The TEACHER' );
        Game.titles.push( 'The DEPUTY' );
        Game.titles.push( 'The MODEL' );
        Game.titles.push( 'The COMPOSER' );
        Game.titles.push( 'The INTERN' );
        Game.titles.push( 'The CADDY' );
        Game.titles.push( 'The LIFEGUARD' );
        Game.titles.push( 'The JUDGE' );
        Game.titles.push( 'The REFEREE' );
        Game.titles.push( 'The DENTIST' );
        Game.titles.push( 'The CODER' );
        Game.titles.push( 'The RANGER' );
        Game.titles.push( 'The SHERIFF' );
        Game.titles.push( 'The ATTORNEY' );
        Game.titles.push( 'The LOVER' );
        Game.titles.push( 'The BUYER' );
        Game.titles.push( 'The PRO' );
        Game.titles.push( 'The KNIGHT' );
        
        //Victim names
        Game.victimNames.push( 'Ms. Golden' );
        Game.victimNames.push( 'Ms. Cheer' );
        Game.victimNames.push( 'Ms. Fairchild' );
        Game.victimNames.push( 'Ms. Golightly' );
        Game.victimNames.push( 'Ms. Grace' );
        Game.victimNames.push( 'Ms. Jewel' );
        Game.victimNames.push( 'Mr. Bloom' );
        Game.victimNames.push( 'Mr. Blythe' );
        Game.victimNames.push( 'Mr. Freeman' );
        Game.victimNames.push( 'Mr. Goodman' );
        Game.victimNames.push( 'Mr. Brightman' );
        Game.victimNames.push( 'Mr. Friend' );
        Game.victimNames.push( 'Mr. Winsome' );
        Game.victimNames.push( 'Mr. Lucky' );
        Game.victimNames.push( 'Mr. Happy' );
        Game.victimNames.push( 'Mrs. Bloom' );
        Game.victimNames.push( 'Mrs. Joyce' );
        Game.victimNames.push( 'Mrs. Holiday' );
        
        //Crimes are pre-fixed by VictimName and post fixed by CrimeLocation
        Game.crimes.push( ' was found dead, with a fractured skull, ' );
        Game.crimes.push( ' was found dead, from multiple stab wounds, ' );
        Game.crimes.push( ' was found dead, with a broken neck, ' );
        Game.crimes.push( ' was found in several pieces, ' );
        Game.crimes.push( ' was found chopped in half, ' );
        Game.crimes.push( ' was found without head, ' );
        Game.crimes.push( ' was found decapitated, ' );
        Game.crimes.push( ' was found shot in the head, ' );
        Game.crimes.push( ' was found dead from multiple gunshots, ' );
        Game.crimes.push( ' was found dead from a single gunshot, ' );
        Game.crimes.push( ' was found murdered with an axe, ' );
        Game.crimes.push( ' was found dead and cowered in purple paint, ' );
        Game.crimes.push( ' was found dead and wearing a pharaoh costume, ' );
        Game.crimes.push( ' was found drowned, ' );
        Game.crimes.push( ' was found choked in pumpkin, ' );
        Game.crimes.push( ' was found choked in mustard, ' );
        
        
        //Crime locations
        Game.locations.push( 'at the office.' );
        Game.locations.push( 'at the shopping mall.' );
        Game.locations.push( 'at the harbor.' );
        Game.locations.push( 'below the bridge.' );
        Game.locations.push( 'in the park.' );
        Game.locations.push( 'in the basement.' );
        Game.locations.push( 'in the bedroom.' );
        Game.locations.push( 'in the bathroom.' );
        Game.locations.push( 'in the refrigirator.' );
        Game.locations.push( 'in the freezer.' );
        Game.locations.push( 'in the kitchen.' );
        Game.locations.push( 'in the closet.' );
        Game.locations.push( 'in the sewers.' );
        Game.locations.push( 'in the parking lot.' );
        Game.locations.push( 'at the train station.' );
        Game.locations.push( 'at the police station.' );
        Game.locations.push( 'at the hospital.' );
        Game.locations.push( 'at home.' );
        Game.locations.push( 'in the bathtub.' );
        Game.locations.push( 'on the roof.' );
    };
    
// public methods:    
    p.tick = function() {
        
    };
    
window.Game = Game;
}(window));