(function() {

// constructor
function PlayScene(id, game) {
	this.GameScene_constructor(id, game);
	
    //prepare assets
    var gfxs = [
            {id:"bg_60x40", src:GFX_ROOT+"bg_60x40.png"},
            {id:"bg2", src:GFX_ROOT+"bg2.jpg"},
            {id:"penis_head", src:GFX_ROOT+"penis_head.png"},
            {id:"penis_strip", src:GFX_ROOT+"penis_strip.png"},
            {id:"hitler_tank", src:GFX_ROOT+"hitler_tank.png"},
            {id:"hitler_tank_hit", src:GFX_ROOT+"hitler_tank_hit.png"},
            {id:"hitler_tank_exhaust", src:GFX_ROOT+"hitler_tank_exhaust.png"},
            {id:"shot_light", src:GFX_ROOT+"shot_light.png"},
            {id:"shot_yellow", src:GFX_ROOT+"shot_yellow.png"},
            {id:"bullet_light", src:GFX_ROOT+"bullet_light.png"},
            {id:"start_button", src:GFX_ROOT+"start_button.png"},
            {id:"life_counter2", src:GFX_ROOT+"life_counter2.png"},
            {id:"moon_overlay", src:GFX_ROOT+"moon_overlay.png"},
            {id:"explosion3", src:GFX_ROOT+"explosion3.png"}
           ];
    this.addManifest(gfxs);
    
    var sfxs = [
            {id:"Explosion39", src:SFX_ROOT+"Explosion39.ogg"},
            {id:"Explosion40", src:SFX_ROOT+"Explosion40.ogg"},
            {id:"Explosion41", src:SFX_ROOT+"Explosion41.ogg"},
            {id:"Explosion42", src:SFX_ROOT+"Explosion42.ogg"},
            {id:"Laser_Shoot24", src:SFX_ROOT+"Laser_Shoot24.ogg"},
            {id:"Laser_Shoot25", src:SFX_ROOT+"Laser_Shoot25.ogg"},
            {id:"Laser_Shoot26", src:SFX_ROOT+"Laser_Shoot26.ogg"},
            {id:"Laser_Shoot27", src:SFX_ROOT+"Laser_Shoot27.ogg"},
            {id:"Powerup3", src:SFX_ROOT+"Powerup3.ogg"},
            {id:"Powerup4", src:SFX_ROOT+"Powerup4.ogg"},
            {id:"music5", src:SFX_ROOT+"music7.ogg"}
           ];
    this.addManifest(sfxs);
    
    this._points = new Array();
    this._vPoints = new Array();
    this._vSticks = new Array();
    
    this._bulletContainer = null;
    this._enemyContainer = null;
    this._penisHead = null;
    this._penisShape = null;
    this._penisContainer = null;
    this._penisCollisionTimer = 0;
    this._enemyCreationTimer = Utility.random(100, 400);
    this._maxEnemyCreationTime = 300;
    
    this._shotPool = new Array();
    this._bulletPool = new Array();
    this._enemies = new Array();
    this._explosionPool = new Array();
    
    //this._scoreText = null;
    this._score = 0;
    
    this._introContainer = null;
    this._uiContainer = null;
    this._dialogBg = null;
    this._startButton = null;
    
    this._moon = null;
    this._moonPieces = 10;
    this._enemiesEscaped = 0;
    
    this._paused = true;
}
var p = createjs.extend(PlayScene, GameScene);

// public methods:
p.enterScene = function() {
    console.log("EnterScene: " + this.id);
    
    //create background       
    //var bgImage = new createjs.Bitmap( this.getLoadResult("bg_60x40", 16) );
    var bgImage = new createjs.Bitmap( this.getLoadResult("bg2") );
    this.addChild(bgImage);
    
    txt.FontLoader.path = "./fonts/"
    
    /*this._dialogBox = new DialogBox();
    this._dialogBox.x = GameEngine.W/2 - (this._dialogBox.getBounds().width/2);
    this._dialogBox.y = GameEngine.H/2 - (this._dialogBox.getBounds().height/2);
    this.addChild(this._dialogBox);*/
    
    this._moon = new createjs.Shape();
    this._moon.x = 161;
    this._moon.y = 135;
    this._moon.graphics.beginFill("#7699bf");
    this._moon.graphics.moveTo(0,0);
    this._moon.graphics.arc(0, 0, 37, 0, Math.PI*((this._moonPieces-this._enemiesEscaped)/(this._moonPieces/2)));
    this._moon.graphics.endFill();
    this.addChild(this._moon);
    
    var moonOverlay = new createjs.Bitmap( this.getLoadResult("moon_overlay") );
    moonOverlay.x = 125;
    moonOverlay.y = 100;
    this.addChild(moonOverlay);
    
    this._bulletContainer = new createjs.Container();
    this.addChild(this._bulletContainer);
    
    this._enemyContainer = new createjs.Container();
    this.addChild(this._enemyContainer);
    
    this._penisContainer = new createjs.Container();
    this.addChild(this._penisContainer);
    
    this._uiContainer = new createjs.Container();
    this._uiContainer.visible = false;
    this.addChild(this._uiContainer);
    
    this._introContainer = new createjs.Container();
    this.addChild(this._introContainer);
    
    /*this._scoreText = new createjs.Text("0","bold 50px Arial","#CCC");
    this._scoreText.textAlign = "center";
    this._scoreText.x = GameEngine.W/2;
    this._scoreText.y = 80;
    this._uiContainer.addChild(this._scoreText);*/
    
    var lifeCounterBg = new createjs.Bitmap( this.getLoadResult("life_counter2") );
    lifeCounterBg.x = 5;
    lifeCounterBg.y = 5;
    this._uiContainer.addChild(lifeCounterBg);
    
    this._lifeText = new createjs.Text("7","bold 30px Arial","#EEE");
    this._lifeText.textAlign = "center";
    this._lifeText.x = 58;
    this._lifeText.y = 6;
    this._uiContainer.addChild(this._lifeText);
    
    this._escapeText = new createjs.Text("0/10","bold 16px Arial","#EEE");
    this._escapeText.textAlign = "center";
    this._escapeText.x = 162;
    this._escapeText.y = 172;
    this._uiContainer.addChild(this._escapeText);
    
    this._dialogBg = new createjs.Shape();
    this._dialogBg.graphics.beginFill(createjs.Graphics.getRGB(0,0,0,0.75)).drawRoundRect(0, 0, 400, 80, 10).endFill();
    this._dialogBg.cache(0, 0, 400, 80);
    this._dialogBg.x = GameEngine.W/2 - this._dialogBg.getBounds().width/2;
    this._dialogBg.y = 170;
    this._introContainer.addChild(this._dialogBg);
    
    this._introText = new createjs.Text("The nazis are taking the moon (again).\nYou must stop them!","bold 28px Arial","#CCC");
    this._introText.maxWidth = 350;
    this._introText.x = GameEngine.W/2;
    this._introText.y = this._dialogBg.y + 10;
    this._introText.textAlign = "center";
    this._introContainer.addChild(this._introText);
    
    this._startButton = new Button( this.getLoadResult("start_button") );
    this._startButton.x = GameEngine.W/2 - this._startButton.getBounds().width/2;
    this._startButton.y = 300;
    this._introContainer.addChild(this._startButton);
    this._startButton.on("click", this._startListener, this);
    
    //setup spritesheets
    this._explosionSheet = new createjs.SpriteSheet( {
        framerate: 20,
        images:[ GFX_ROOT+"explosion3.png" ],
        frames:{width:100, height:100, count:5, regX:50, regY:50},
        animations:{explode: {frames: [0,1,2,3,4], next: false, speed: 0.2}}
    });
    
    this.on("click", this._clickListener);
    
    //fade in
    /*this.alpha = 0.0;
    createjs.Tween.get(this, {loop:false, override:true}).to({alpha:1.0}, 1000, createjs.Ease.cubicInOut);*/
};

p.exitScene = function(newScene) {
    //TODO: clean up
    console.log("ExitScene: " + this.id);
    
    //set new scene
    GameEngine.engine.setScene(newScene);
};

p.tick = function(e) {
    
    if (!this._paused) {
        var i, j = 0;
        
        for (i = 0; i < this._bulletPool.length; i++) {
            if (this._bulletPool[i].active) {
                this._bulletPool[i].tick();
                
                for (var j = 0; j < this._enemies.length; j++) {
                    if (this._enemies[j].collides(this._bulletPool[i].x, this._bulletPool[i].y, 38)) {
                        //console.log("HIT");
                        
                        this._enemies[j].energy -= 1;
                        
                        this._bulletPool[i].active = false;
                        this._bulletContainer.removeChild(this._bulletPool[i]);
                        
                        if (this._enemies[j].energy <= 0) {
                            this._destroyEnemy(j);
                        }
                        else {
                            this._enemies[j].flash();
                        }
                    }
                }
            }
        }
        
        /*this._penisCollisionTimer = Math.max(this._penisCollisionTimer-1, 0);
        for (var j = 0; j < this._enemies.length; j++) {
            for (var i = 0; i < this._vPoints.length; i++) {
                if (this._enemies[j].collides(this._vPoints[i].x, this._vPoints[i].y, 38) && this._penisCollisionTimer == 0) {
                    if (this._vSticks.length > 1) {
                        this._vSticks.pop();
                        this._vPoints.pop();
                        this._penisCollisionTimer = 30;
                        
                        this._lifeText.text = this._vSticks.length;
                    }
                    else {
                        console.log("GAME OVER");
                    }
                }
            }
        }*/
        
        this._enemyCreationTimer = Math.max(this._enemyCreationTimer-1, 0);
        if (this._enemyCreationTimer == 0) {
            this._createEnemy();
            
            this._maxEnemyCreationTime = Math.max(this._maxEnemyCreationTime-2, 150);
            this._enemyCreationTimer = Utility.random(100,this._maxEnemyCreationTime);
        }
        
        for (i = 0; i < this._enemies.length; i++) {
            if (this._enemies[i].active) {
                this._enemies[i].tick();
                
                if (this._enemies[i].isMovingRight()) {
                    if (this._enemies[i].isDriving() && ((this._enemies[i].x > 50 && Math.random() < 0.00175) || this._enemies[i].x > GameEngine.W/2 - 100)) {
                        this._enemies[i].startLaunch();
                    }
                }
                else {
                    if (this._enemies[i].isDriving() && ((this._enemies[i].x < GameEngine.W - 50 && Math.random() < 0.00175) || this._enemies[i].x < GameEngine.W/2 + 100)) {
                        this._enemies[i].startLaunch();
                    }
                }
            }
            else {
                this._enemyContainer.removeChild(this._enemies[i]);
                this._enemies.splice(i, 1);
                i--;
                
                this._enemiesEscaped++;
                this._moon.graphics.clear();
                this._moon.graphics.beginFill("#7699bf");
                this._moon.graphics.moveTo(0,0);
                this._moon.graphics.arc(0, 0, 37, 0, Math.PI*((this._moonPieces-this._enemiesEscaped)/(this._moonPieces/2)));
                this._moon.graphics.endFill();
                
                this._escapeText.text = this._enemiesEscaped + "/" + this._moonPieces;
                
                if (this._enemiesEscaped == this._moonPieces) {
                    this._paused = true;
                    this._introText.text = "The nazis have taken the moon,\nbut you reached an amazing " + this._vSticks.length + " inches!";
                    
                    //this._penisContainer.visible = false;
                    this._introContainer.visible = true;
                    this._uiContainer.visible = false;
                    
                    createjs.Sound.play("Powerup4", {volume:0.25});
                }
                else {
                    createjs.Sound.play("Powerup3", {volume:0.25});
                }
            }
        }
        
        this._vPoints[0].setPos(this.getStage().mouseX, this.getStage().mouseY);
        
        for (i = 0; i < this._vPoints.length; i++) {
            this._vPoints[i].y += 1.0; //gravity
            this._vPoints[i].update();
            if (this._vPoints[i].y > GameEngine.H - 120) {
                this._vPoints[i].setPos(this._vPoints[i].x, GameEngine.H - 120);
                
                /*this._penisCollisionTimer = Math.max(this._penisCollisionTimer-1, 0);
                if (this._vSticks.length > 1 && this._penisCollisionTimer == 0) {
                    this._vSticks.pop();
                    this._vPoints.pop();
                    this._penisCollisionTimer = 500;
                    
                    this._lifeText.text = this._vSticks.length;
                }*/
            }
        }
        
        for (i = 0; i < 20; i++) {
            for (j = 0; j < this._vSticks.length; j++) {
                this._vSticks[j].constrain();
            }
        }
        
        this._penisShape.graphics.clear();
        this._penisShape.graphics.setStrokeStyle(20,"round").beginStroke("#FAB693");
        
        //this._penisShape.graphics.moveTo(this.getStage().mouseX, this.getStage().mouseY);
        //this._penisShape.graphics.lineTo(this._vSticks[0].pointA.x, this._vSticks[0].pointA.y);
        
        for (i = 0; i < this._vSticks.length; i++) {
            this._penisShape.graphics.moveTo(this._vSticks[i].pointA.x, this._vSticks[i].pointA.y);
            this._penisShape.graphics.lineTo(this._vSticks[i].pointB.x, this._vSticks[i].pointB.y);
            
            var deltaY = this._vSticks[i].pointB.y - this._vSticks[i].pointA.y;
            var deltaX = this._vSticks[i].pointB.x - this._vSticks[i].pointA.x;
            var angleInDegrees = Math.atan2(deltaY, deltaX) * 180 / Math.PI;
            
            if (i == this._vSticks.length-1) {
                this._penisHead.rotation = angleInDegrees + 90;
                this._penisHead.regX = this._penisHead.getBounds().width / 2;
                this._penisHead.regY = this._penisHead.getBounds().height;
                this._penisHead.x = this._vSticks[i].pointB.x;
                this._penisHead.y = this._vSticks[i].pointB.y;
            }
        }
    }
};

// private methods:
p._clickListener = function(e, data) {
    //console.log("click on: " + data.xIndex + ", " + data.yIndex);
    //console.log( this.getObjectsUnderPoint(this.getStage().mouseX, this.getStage().mouseY) );
    
    this._fireBullet(this._penisHead.x, this._penisHead.y);
    
    //this._vPoints.push(new VPoint(this._vPoints[this._vPoints.length-1].x, this._vPoints[this._vPoints.length-1].y+10));
    //this._vSticks.push(new VStick(this._vPoints[this._vPoints.length-2], this._vPoints[this._vPoints.length-1]));
};

p._startListener = function(e, data) {
    //console.log("click on: " + data.xIndex + ", " + data.yIndex);
    //console.log( this.getObjectsUnderPoint(this.getStage().mouseX, this.getStage().mouseY) );
    this._enemies = new Array();
    this._enemyContainer.removeAllChildren();
    this._penisContainer.removeAllChildren();
    this._bulletContainer.removeAllChildren();
    
    this._createPenis();
    this._createEnemy();
    
    this._paused = false;
    this._penisContainer.visible = true;
    this._introContainer.visible = false;
    this._uiContainer.visible = true;
    
    this._enemiesEscaped = 0;
    this._moon.graphics.clear();
    this._moon.graphics.beginFill("#7699bf");
    this._moon.graphics.moveTo(0,0);
    this._moon.graphics.arc(0, 0, 37, 0, Math.PI*((this._moonPieces-this._enemiesEscaped)/(this._moonPieces/2)));
    this._moon.graphics.endFill();
    
    e.stopPropagation();
    
    createjs.Sound.stop();
    createjs.Sound.play("music5", {volume:1.0, loop:-1});
};

p._downListener = function(e, data) {
    //console.log("down on: " + data.xIndex + ", " + data.yIndex);
    
    this._mouseDown = true;
};

p._upListener = function(e, data) {
    //console.log("up on: " + data.xIndex + ", " + data.yIndex);
    //console.log(this._cells);
    
    this._mouseDown = false;
};

p._overListener = function(e, data) {
    //console.log("over on: " + data.xIndex + ", " + data.yIndex);
};

p._outListener = function(e, data) {
    //console.log("out on: " + data.xIndex + ", " + data.yIndex);
};

p._createPenis = function() {
    this._points = new Array();
    this._vPoints = new Array();
    this._vSticks = new Array();
    
    for(var p = 0; p < 6; p++) {
        this._points.push(new createjs.Point(GameEngine.W/2, GameEngine.H/2 + p * 10));
    }
    
    for(var q = 0; q < this._points.length; q++) {
        this._vPoints.push(new VPoint(this._points[q].x, this._points[q].y));
        if (q > 0) {
            this._vSticks.push(new VStick(this._vPoints[q-1], this._vPoints[q]));
        }
    }
    this._penisShape = new createjs.Shape();
    this._penisShape.mouseEnabled = false;
    this._penisContainer.addChild(this._penisShape);
    
    this._penisHead = new createjs.Bitmap( this.getLoadResult("penis_head") );
    this._penisHead.x = -100;
    this._penisHead.mouseEnabled = false;
    this._penisContainer.addChild(this._penisHead);
    
    this._lifeText.text = this._vSticks.length;
};

p._createEnemy = function() {
    var enemy = new EnemyTank(this);
    
    if (Math.random() > 0.5) {
        enemy.x = -enemy.getBounds().width/2;
        enemy.setVelocity(1, 0);
    }
    else {
        enemy.x = GameEngine.W + enemy.getBounds().width/2;
        enemy.setVelocity(-1, 0);
    }
    enemy.y = GameEngine.H - 15;
    this._enemyContainer.addChild(enemy);
    this._enemies.push(enemy);
};

p._destroyEnemy = function(index) {
    this._addExplosion(this._enemies[index].x, this._enemies[index].y - 70);
    
    //createjs.SoundJS.play("exp2", createjs.SoundJS.INTERRUPT_NONE);
    
    this._enemyContainer.removeChild(this._enemies[index]);
    this._enemies.splice(index, 1);
    
    //this._score += 1;
    //this._scoreText.text = this._score;
    
    this._lifeText.text = this._vSticks.length;
    
    this._vPoints.push(new VPoint(this._vPoints[this._vPoints.length-1].x, this._vPoints[this._vPoints.length-1].y+10));
    this._vSticks.push(new VStick(this._vPoints[this._vPoints.length-2], this._vPoints[this._vPoints.length-1]));
    
    createjs.Sound.play("Explosion"+Utility.random(39,42), {volume:0.25});
};

p._fireBullet = function(xPos, yPos) {
    //create the bullet
    var bullet = this._bulletPool[this._getBulletIndex()];
    bullet.x = xPos;
    bullet.y = yPos;
    
    bullet.bulletSpeed = 0.5;
    
    var deltaY = this._vSticks[this._vSticks.length-1].pointB.y - this._vSticks[this._vSticks.length-1].pointA.y;
    var deltaX = this._vSticks[this._vSticks.length-1].pointB.x - this._vSticks[this._vSticks.length-1].pointA.x;
    
    bullet.setDirection(deltaX, deltaY);
    bullet.active = true;
    
    createjs.Sound.play("Laser_Shoot"+Utility.random(24,27), {volume:0.05});
};

p._getBulletIndex = function() {
    var i = 0;
    var len = this._bulletPool.length;
    
    while (i <= len){
        if (!this._bulletPool[i]) {
            this._bulletPool[i] = new Bullet(this);
            break;
        } else if (!this._bulletPool[i].active) {
            this._bulletPool[i].active = true;
            break;
        } else {
            i++;
        }
    }

    if (len == 0) {
        this._bulletPool[0] = new Bullet(this);
    }

    this._bulletContainer.addChild(this._bulletPool[i]);
    return i;
};

p._addExplosion = function(xPos, yPos) {
    //create the bullet
    var explosion = this._explosionPool[this._getExplosionIndex()];
    explosion.gotoAndPlay("explode");
    explosion.x = xPos;
    explosion.y = yPos;
    explosion.active = true;
};

p._getExplosionIndex = function() {
    var i = 0;
    var len = this._explosionPool.length;
    
    while (i <= len){
        if (!this._explosionPool[i]) {
            this._explosionPool[i] = new createjs.Sprite( this._explosionSheet );
            this._explosionPool[i].on("animationend", this._removeExplosion, this);
            break;
        } else if (!this._explosionPool[i].active) {
            this._explosionPool[i].active = true;
            break;
        } else {
            i++;
        }
    }

    if (len == 0) {
        this._explosionPool[0] = new createjs.Sprite( this._explosionSheet );
        this._explosionPool[0].on("animationend", this._removeExplosion, this);
    }

    this.addChild(this._explosionPool[i]);
    return i;
};

p._removeExplosion = function(e) {
    this.removeChild(e.target);
};

p._actionText = function(text, x, y, fontSize, jumpSize, fadeDelay, fontColor) {
    var t = new createjs.Text(text.toString(), fontSize + "px DetectiveBold", fontColor);
    t.x = x - t.getBounds().width/2;
    t.y = y - t.getBounds().height/2;
    this._gameGuiContainer.addChild(t);
    
    createjs.Tween.get(t, {loop:false, override:true}).to({y:t.y-jumpSize}, 500, createjs.Ease.cubicOut).wait(fadeDelay).to({alpha:0.0}, 250, createjs.Ease.cubicInOut).call(this.removeChild,[t],this) ;
};

p._getRect = function(w, h, color) {
    var container = new createjs.Container();
    var rect = new createjs.Shape();
    var line = new createjs.Shape();
    rect.graphics.beginFill(createjs.Graphics.getRGB(0,0,0,0.01)).drawRect(0, 0, w, h).endFill();
    line.graphics.beginFill(createjs.Graphics.getRGB(255,255,255,1.0)).drawRect(0, h-2, w, 2).endFill();
    rect.regX = line.regX = 0;
    rect.regY = line.regY = 0;
    rect.cache(0, 0, w, h);
    line.cache(0, h-2, w, h-2);
    container.addChild(rect);
    container.addChild(line);
    
    return container;
};

p._getGrid = function(w, h, xCount, yCount) {
    var grid = new createjs.Shape();
    for (var i = 0; i < xCount; i++) {
        for (var j = 0; j < yCount; j++) {
            grid.graphics.setStrokeStyle(3).beginStroke("#5E5E5E").beginFill(createjs.Graphics.getRGB(255,0,0,0.0)).drawRect(i * (w/xCount), j * (h/yCount), w/xCount, h/yCount).endFill();
        }
    }
    
    grid.regX = w/2;
    grid.regY = h/2;
    grid.cache(0, 0, w, h);
    
    return grid;
};

window.PlayScene = createjs.promote(PlayScene, "GameScene");
}());