(function() {

//
function Bullet(parentScene) {
    this.Container_constructor();
  
    this._parentScene = parentScene;
    
    this.bulletSpeed = 3.0;
    this.active = false;
    
	this._vX = 0;
	this._vY = 0;
    
    //add childs
    this._bullet = new createjs.Bitmap( this._parentScene.getLoadResult("shot_yellow") );
    this._bullet.cache(0, 0, this._bullet.getBounds().width, this._bullet.getBounds().height);
    this._bullet.regX = this._bullet.getBounds().width/2;
    this._bullet.regY = this._bullet.getBounds().height + 10;
    this.addChild(this._bullet);
};
var p = createjs.extend(Bullet, createjs.Container);

// public methods:	
p.tick = function(){
    //move by velocity
    this.x += this._vX * this.bulletSpeed;
    this.y += this._vY * this.bulletSpeed;
    
    if (this.active) {
        if (this.y > GameEngine.H + 8 || this.y < -8) {
            this.active = false;
        }
        else if (this.x > GameEngine.W + 8|| this.x < -8) {
            this.active = false;
        }
    }
};

p.setDirection = function(xDir, yDir) {
    this._vX = xDir;
    this._vY = yDir;
    
    var angleInDegrees = Math.atan2(this._vY, this._vX) * 180 / Math.PI;
    
    this.rotation = angleInDegrees + 90;
};

window.Bullet = createjs.promote(Bullet, "Container");
}());