(function() {

// constructor
function VPoint(x, y) {
    this.x = 0;
    this.y = 0;
    this.oldX = 0;
    this.oldY = 0;
    
    this.setPos(x, y);
};
var p = VPoint.prototype;

// public methods:
p.setPos = function(x, y){
    this.x = this.oldX = x;
    this.y = this.oldY = y;
};

p.update = function(){
    var tempX = this.x;
    var tempY = this.y;
    
    this.x += this.x - this.oldX;
    this.y += this.y - this.oldY;
    
    this.oldX = tempX;
    this.oldY = tempY;
};

window.VPoint = VPoint;
}());