(function() {

// constructor
function VStick(pA, pB) {
    
    this.pointA = pA;
    this.pointB = pB;
    
    var dX = pA.x - pB.x;
    var dY = pA.y - pB.y;
    
    this.length = Math.sqrt((dX * dX) + (dY * dY));
};
var p = VStick.prototype;

// public methods:
p.constrain = function(){
    var dX = this.pointB.x - this.pointA.x;
    var dY = this.pointB.y - this.pointA.y;
    var dH = Math.sqrt((dX * dX) + (dY * dY));
    var diff = this.length - dH;
    
    var offX = (diff * (dX/dH)) * 0.5;
    var offY = (diff * (dY/dH)) * 0.5;
    
    this.pointA.x -= offX;
    this.pointA.y -= offY;
    this.pointB.x += offX;
    this.pointB.y += offY;
    
};

window.VStick = VStick;
}());